dnl -*- coding:utf-8; mode:m4; -*-

dnl SYNOPSYS
dnl
dnl   AX_PROG_DIRNAME([GNU])
dnl
dnl DESCRIPTION
dnl
dnl   Check for the `dirname' program and set DIRNAME to it if found.
dnl   Otherwise, define DIRNAME to be the replacement script
dnl   `$ac_aux_dir/dirname.sh.  If the optional parameter is given and equals
dnl   `GNU', require the `dirname' program to support the additional options
dnl   accepted by GNU dirname.  (The supplied replacement script supports
dnl   these so it doesn't make your package less portable if you require this
dnl   convenience.  On the other hand, if you don't need it, using a natively
dnl   compiled program will certainly be faster.)
dnl
dnl LICENSE
dnl
dnl   Copyright (c) 2013 Moritz Klammler <moritz@klammler.eu>
dnl
dnl   Copying and distribution of this file, with or without modification, are
dnl   permitted in any medium without royalty provided the copyright notice and
dnl   this notice are preserved.  This file is offered as-is, without any
dnl   warranty.
dnl
AC_DEFUN([AX_PROG_DIRNAME], [
  AC_REQUIRE([AC_PROG_SED])
  AC_CHECK_PROGS([DIRNAME], [dirname])
  AS_IF([test "x$DIRNAME" = x], [DIRNAME=false], [m4_strip([
        _ax_prog_dirname="$DIRNAME"
        test "$($DIRNAME /usr/bin/sort 2>/dev/null)" = /usr/bin || DIRNAME=false
        test "$($DIRNAME /usr/bin//.// 2>/dev/null)" = /usr/bin || DIRNAME=false
        test "$($DIRNAME stdio.h 2>/dev/null)" = . || DIRNAME=false
        test "$($DIRNAME -- --help 2>/dev/null)" = . || DIRNAME=false
      ])
      m4_if([$1], [GNU], [m4_strip([
        # Test for GNU dirname features.
        test "$($DIRNAME dir1/str dir2/str 2>/dev/null)" dnl
          = "$(echo dir1; echo dir2)" || DIRNAME=false
        test "$($DIRNAME --zero 'white space/name' other/name 2>/dev/null)" dnl
          = "$(printf 'white space\0other')" || DIRNAME=false
        test "$($DIRNAME -z 'white space/name' other/name 2>/dev/null)" dnl
          = "$(printf 'white space\0other')" || DIRNAME=false
      ])], [m4_ifnblank([$1], [
        m4_fatal([AX_PROG_DIRNAME: if present, the optional argument must be `GNU', not `$1'])
      ])])
      AS_IF([test "$DIRNAME" = false], [
        AC_MSG_WARN([$_ax_prog_dirname: does not work as expected])
        unset _ax_prog_dirname
      ])
    ])
  AS_IF([test "$DIRNAME" = false], [
dnl TODO: Is is correct that we use $ac_aux_dir like this?
    DIRNAME="$SHELL $srcdir/$ac_aux_dir/dirname.sh"
    AC_REQUIRE_AUX_FILE([dirname.sh.in])
    AC_CONFIG_FILES([$srcdir/$ac_aux_dir/dirname.sh])
  ])
])
